#line 1 "E:/Microcontroller Projects/Garage Monitor/DS18B20_Get_ID.c"
#line 33 "E:/Microcontroller Projects/Garage Monitor/DS18B20_Get_ID.c"
const char EEPROM_offset = 0x30;
char SlaveROM[8];
float temperature;


sbit LCD_RS at LATB4_bit;
sbit LCD_EN at LATB5_bit;
sbit LCD_D4 at LATB0_bit;
sbit LCD_D5 at LATB1_bit;
sbit LCD_D6 at LATB2_bit;
sbit LCD_D7 at LATB3_bit;
sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;



void Comm_Delay() {Delay_us(10);}
void Delay_10() {Delay_ms(10);}
void Delay_20() {Delay_ms(20);}
void Delay_200() {Delay_ms(200);}
void Delay_100() {Delay_ms(100);}
void Delay_500() {Delay_ms(500);}

void getSlaveROM(){
 char i, tmp[3];
 INTCON.GIE = 0;
 Ow_Reset(&PORTE, 2);
 Delay_us(140);
 Ow_Write(&PORTE, 2, 0x33);
 Delay_us(140);
 for(i=0; i<8; i++)SlaveROM[i] = Ow_Read(&PORTE, 2);
 INTCON.GIE = 1;
 for(i=0; i<8; i++)EEPROM_write(i+EEPROM_offset, SlaveROM[i]);
}

void getDS18B20(){
 unsigned int temp;
 INTCON.GIE = 0;
 Ow_Reset(&PORTE, 2);
 Delay_us(140);
 Ow_Write(&PORTE, 2, 0xCC);
 Ow_Write(&PORTE, 2, 0x44);

 Ow_Reset(&PORTE, 2);
 Delay_us(140);

 Ow_Write(&PORTE, 2, 0xCC);
 Ow_Write(&PORTE, 2, 0xBE);
 temp = Ow_Read(&PORTE, 2);
 temp = (Ow_Read(&PORTE, 2) << 8) + temp;
 temperature = (temp & 0x000F) * (.0625);
 temperature = (temperature + (temp >> 4)) * 9 / 5 + 32;

 INTCON.GIE = 1;
}

void Display_It(){
 char txt[7], tmp[3];
 int i;
 Lcd_Cmd(_LCD_CLEAR);
 byteToStr(EEPROM_offset, tmp);
 Lcd_Out(1, 14, tmp);
 i = temperature;
 IntToStr(i, txt);
 Lcd_Out(1, 4, txt);
 Lcd_Out(1, 1, "Temp:");
 for(i=0; i<8; i++){ByteToHex(SlaveROM[i],tmp); Lcd_Out(2, 15-2*i, tmp);}
 Delay_500();
}




void main(){
 INTCON = 0;
 ADCON0 = 0;
 ANSELA = 0;
 ANSELB = 0;
 ANSELC = 0;
 ANSELD = 0;
 ANSELE = 0;
#line 125 "E:/Microcontroller Projects/Garage Monitor/DS18B20_Get_ID.c"
 LATD = 0;
 TRISD = 0xff;
 LATE = 0;
 TRISE = 4;

 getDS18B20(); while(temperature == 185) getDS18B20();
 Lcd_Init();
 Delay_10();
 Lcd_Cmd(_LCD_CLEAR);
 Delay_10();
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Delay_10();

 getSlaveROM();
 do {
 getDS18B20();
 Display_It();
 }while(1);
}
